$.fn.updateFlashcardContainerHeight = function(){
  container = $(this);
  var doUpdate = function(){
    console.log('updateFlashcardContainerHeight');
    var new_height;
    // There may be multiple flashcards loaded into the dom, so always use the last
    // one for calculations (it's about to slide in)
    if (container.find('.flashcard').first().hasClass('flipped')) {
      new_height = container.find('.flashcard .back').first().height();
    } else {
      new_height = container.find('.flashcard .front').first().height();
    }
    new_height += parseInt(container.css('margin-bottom'));
    
    $('.flashcard-container-footer').each(function(){
      var target = $(this);
      if (!target.hasClass('animated')){
        setTimeout(function(){
          target.addClass('animated');
        }, 300);
      }
      target.css('transform', 'translateY(' + new_height + 'px)');
    });
  
    // container.height(0);
  }
  
  if (container.find('.flashcard img').length == 0){
    doUpdate();
  } else {
    container.find('.flashcard img').on('load', doUpdate).first().each(function(){
      if(this.complete) $(this).load();
    });
  }
}

// called on a .flashcard element
$.fn.flipFlashcard = function(){
  $(this).addClass('flipped').closest('.flashcard-container').updateFlashcardContainerHeight();
  var target = $(this).children('.front');
  setTimeout(function(){
    target.css('visibility', 'hidden');
  }, 300);
}
