'use strict';

// http://stackoverflow.com/questions/20024156/how-to-watch-changes-on-models-created-by-ng-repeat

angular.module('magooshFlashcardApp').controller('FlashcardController', ['$scope', '$mixpanel', function ($scope, $mixpanel) {
  
  // wasKnown should be a boolean
  $scope.submitAnswer = function(wasKnown) {
    $scope.$parent.submitCard($scope.card, wasKnown);
    $mixpanel.trackOnce('Answer');
    
    // track click
    if (wasKnown) {
      gaRecordEvent("Button", "Click", "was_known", 1);
    } else {
      gaRecordEvent("Button", "Click", "not_known", 1);
    }
  };
}]);
